#include <avr/io.h>
#include <util/delay.h>
#include "nRF905_Config.h"
#include "nRF905.h"

unsigned char ReceiveBuffer[BUF_SIZE];			// RFջ
unsigned char SendBuffer[BUF_SIZE];			// RFͻ
unsigned char ReceiveCount;				// RFջո
unsigned char SendCount;				// RFͻ͸

void SPI_Init(void)
{
	PORT_SPI |= (1<<MOSI)|(1<<MISO)|(1<<SCK)|(1<<SS);  // MOSISCKSSΪ,Ϊ
	DDR_SPI  |= (1<<MOSI)|(1<<SCK)|(1<<SS);
	SPCR   = (1<<SPE)|(1<<MSTR)|(0<<CPOL)|(0<<SPR0);   // ģʽfck/16, SPIʽ0
}

unsigned char SPI_ReadWrite(unsigned char cData)
{
	SPDR = cData;
	while(!(SPSR & (1<<SPIF) ))			// ȴSPI
		;
	return SPDR;
}

void nRF905_Init(unsigned long nRF_rxaddr)
{
	unsigned char i;
	DDR_NRF905 |= ((1<<TX_EN)|(1<<TRX_CE)|(1<<PWR_UP)|(0<<DR)|(0<<AM)|(0<<CD));
	PORT_NRF905 |= ((0<<TX_EN)|(0<<TRX_CE)|(1<<PWR_UP)|(1<<DR)|(1<<AM)|(1<<CD));

	nRF905_SetConfig(nRF_rxaddr);				// ʼnRF905ýյַ
	nRF905_SetReceiveMode(); 				// Ϊģʽ

	/* ͻջ */
	for(i = 0; i < BUF_SIZE; ++i)
	{
		SendBuffer[i] = 0;
		ReceiveBuffer[i] = 0;
	}
}

unsigned char nRF905_ReadStatus(void)
{
	unsigned char val;

	CLR_SS();					// SPI
	val = SPI_ReadWrite(RC);			// ״̬
	SET_SS();					// رSPI

	return val;
}

void nRF905_SetSendMode(void)
{
	_delay_ms(1);
	SET_TX_EN();					// Ϊģʽ
	/*asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");*/
	_delay_ms(1);
	CLR_TRX_CE();					// PORTD &= ~(1<<TRX_CE);
	_delay_ms(1);
}

void nRF905_SetReceiveMode(void)
{

	/*asm("nop");
	asm("nop");
	asm("nop");
	*/
	CLR_TX_EN();					// Ϊģʽ
	//asm("nop");
	_delay_ms(1);
	SET_TRX_CE();					// ʹܽ
	/*asm("nop");
	asm("nop");
	asm("nop");
	*/
	_delay_ms(1);

}

void nRF905_SendStart(void)
{
	SET_TRX_CE();					// ʼ
	_delay_ms(10);					// while(DR!=1);
	CLR_TRX_CE();					// ģʽ
}

void nRF905_SetConfig(unsigned long nRFAddr)		//nRF905
{
	CLR_TRX_CE();					//nRF905Ϊʽ
	asm("nop");

	CLR_SS();					//SPI
	// ܹ10ֽ
	SPI_ReadWrite(WC);                		// Write config command
	SPI_ReadWrite(CH_NO_BYTE);                       // Ƶʵ8λ
	SPI_ReadWrite(PA_PWR_10dBm | HFREQ_PLL_433MHz); 	// +10dBm,Ƶ433MHz,Ƶʵ9λ=0
	SPI_ReadWrite(TX_AFW_4BYTE | RX_AFW_4BYTE);     	// յַ4ֽ,͵ַ4ֽ  0100 0100
	SPI_ReadWrite(RX_PW_32BYTE);                    	// ݿ32ֽ
	SPI_ReadWrite(TX_PW_32BYTE);                    	// ݿ32ֽ
	SPI_ReadWrite((nRFAddr >> 24));  		// Чַ1ֽ
	SPI_ReadWrite((nRFAddr >> 16) & 0xff);           // Чַ2ֽ
	SPI_ReadWrite((nRFAddr >> 8) & 0xff);            // Чַ3ֽ
	SPI_ReadWrite(nRFAddr & 0xff);                   // Чַ4ֽ  
	SPI_ReadWrite(CRC16_EN | XOF_16MHz);            	// CRC16ģʽʹ,Ƶ16MHz
	SET_SS();					// رSPI

	if ( PORT_NRF905 & (1 << TX_EN) )		//ٻصԭշģʽ
	{
		CLR_TRX_CE();				//nRF905Ϊʽ
	}
	else
	{
		SET_TRX_CE();				//nRF905Ϊʽ
	}

}

void nRF905_ReceivePacket(void)
{
	unsigned char i;
	nRF905_SetReceiveMode();			// ýģʽ
	// CD=1AM=0,DR=0
	//if(   ( PIN_NRF905 & (1<<CD) )
	//		&& ((PIND & ((1<<AM)|(1<<DR)) ) == 0) 
	//  )
	{
		CLR_TRX_CE();				// ģʽ
		asm("nop");
		CLR_SS();
		SPI_ReadWrite(RRP);
		for(i = 0; i < 32; ++i)
		{
			ReceiveBuffer[i] = SPI_ReadWrite(0xff);
		}
		SET_SS();
		while(PIN_NRF905 & ((1<<AM)|(1<<DR)) );		// ȴ
		ReceiveCount = 32;
		SET_TRX_CE();
//		LED_ON();
	}
}

/* Ϊն˵ĵַ͸˭ */
void nRF905_SendPacket(unsigned long nRF_rxaddr)
{
	unsigned char i;
	if( (PIN_NRF905 & ((1<<CD)|(1<<AM)|(1<<DR))) == 0 )	// ܱƵź
	{
		nRF905_SetSendMode();
		//LED_ON();

		asm("nop");
		asm("nop");
		asm("nop");
		_delay_ms(1);
		
		CLR_SS();
		SPI_ReadWrite(WTA);				// д͵ַ
		SPI_ReadWrite((nRF_rxaddr >> 24));  		// Чַ1ֽ
		SPI_ReadWrite((nRF_rxaddr >> 16) & 0xff);           // Чַ2ֽ
		SPI_ReadWrite((nRF_rxaddr >> 8) & 0xff);            // Чַ3ֽ
		SPI_ReadWrite(nRF_rxaddr & 0xff);                   // Чַ4ֽ  
		SET_SS();

		asm("nop");
		asm("nop");
		asm("nop");

		CLR_SS();
		SPI_ReadWrite(WTP);
		for( i = 0; i < 32; ++i )
		{
			SPI_ReadWrite(SendBuffer[i]);
		}
		SET_SS();

		SendCount = 32;
		nRF905_SendStart();					// ʼ
		nRF905_SetReceiveMode();			// ϻصģʽ			

		//LED_OFF();
	}
}


