#include <avr/io.h>

#ifndef _NRF905_LXF_20080318_H
#define	_NRF905_LXF_20080318_H

// SPI pin
#define	PORT_SPI	PORTB
#define	DDR_SPI		DDRB

#define	MOSI		PB5
#define	MISO		PB6
#define	SCK		PB7
#define	SS		PB4

// nRF905 pin
#define	PORT_NRF905	PORTA
#define DDR_NRF905	DDRA
#define PIN_NRF905	PINA

#define TX_EN		PA0
#define	TRX_CE		PA1
#define	PWR_UP		PA2
#define	CD		PA3
#define	AM		PA4
#define	DR		PA5

#define	CLR_BIT(PORT,BIT)	((PORT) &= ~(1<<(BIT)))
#define	SET_BIT(PORT,BIT)	((PORT) |= (1<<(BIT)))

#define	CLR_PWR_UP()		CLR_BIT(PORT_NRF905, PWR_UP)
#define SET_PWR_UP()		SET_BIT(PORT_NRF905, PWR_UP)
#define	CLR_TRX_CE()		CLR_BIT(PORT_NRF905, TRX_CE)
#define	SET_TRX_CE()		SET_BIT(PORT_NRF905, TRX_CE)
#define	CLR_TX_EN()		CLR_BIT(PORT_NRF905, TX_EN)
#define	SET_TX_EN()		SET_BIT(PORT_NRF905, TX_EN)
#define	CLR_SS()		CLR_BIT(PORT_SPI, SS)
#define	SET_SS()		SET_BIT(PORT_SPI, SS)
//#define	LED_ON()		CLR_BIT(PORT_LED, LED)
//#define	LED_OFF()		SET_BIT(PORT_LED, LED)

#define BUF_SIZE	32

extern unsigned char SendBuffer[];
extern unsigned char ReceiveBuffer[];
extern unsigned char ReceiveCount;
extern unsigned char SendCount;

void SPI_Init(void);
void nRF905_Init(unsigned long nRF_rxaddr);
unsigned char SPI_ReadWrite(unsigned char cData);
unsigned char nRF905_ReadStatus(void);
void nRF905_SetSendMode(void);
void nRF905_SetReceiveMode(void);
void nRF905_SendStart(void);
void nRF905_SetConfig(unsigned long nRFAddr);
void nRF905_ReceivePacket(void);
void nRF905_SendPacket(unsigned long nRF_rxaddr);

#endif

